/*******************************************************************************
 * Copyright (c) 2014 Cvisionhk.
 *******************************************************************************/


#include <stdio.h>
#include <string.h>
#include "MQTTMidleware.h"
#include "NetworkAPI.h"

int mqtt_read(Network* n, unsigned char* buffer, int len, int timeout_ms)
    {
    int read;
    TCP_read(n->my_socket, buffer, len, &read);
#if DEBUG
    phexarray(buffer, read, "READ");
#endif

    return read;
    }
int  mqtt_write(Network* n, unsigned char* buffer, int len, int timeout_ms)
    {
    int written = 0;
    TCP_write(n->my_socket, buffer, len, &written);
    return written;
    }
void mqtt_disconnect(Network* n)
    {
    TCP_close(n->my_socket);
    }
int NewNetwork(Network* n)
    {
    n->my_socket = 0;
    n->mqttread = mqtt_read;
    n->mqttwrite = mqtt_write;
    n->disconnect = mqtt_disconnect;
    }
int initTCP(char *host, int port)
    {
    int socket_id;
    char ip[32] = {0};
    resolve_domain(host, ip);
    if(TCP_open(ip, port, &socket_id)<0)
        {
        return -1;
        }
    if (set_socket_read_mode(socket_id, O_NONBLOCK))
        {
        return -1;
        }
    return socket_id;

    }
int ConnectNetwork(Network* n, char* addr, int port1)
    {
    int rt = initTCP(addr, port1);
    if(rt>=0)
        {
        n->my_socket = rt;
        return 0;
        }
    return -1;
    }
